use bitvec::prelude::*;

pub fn unstuff_bits(mut bits: BitVec<u8, Msb0>) -> Option<Vec<u8>> {
    let mut one_count = 0;
    let mut offset = 0;
    for i in 0..bits.len() {
        if one_count == 5 {
            // bit stuffing is expected
            if bits[i] {
                // we expected a zero - this data is invalid. abort
                return None;
            }

            offset += 1;
            one_count = 0;

            continue;
        }

        if bits[i] {
            one_count += 1;
        } else {
            one_count = 0;
        }

        let val = bits[i];
        bits.set(i - offset, val);
    }

    bits.truncate(bits.len() - offset);

    Some(bits.as_raw_slice().to_owned())
}
